/*	 	
		V 1.2 - June 23rd, 2005
		
		Buzztracker by Craig Mod (craigmod.com) (c) 2005. 
		Project sponsored by Chin Music Pres (www.chinmusicpress.com)
		This Widget is being released under the 
		Creative Commons Attribution-NonCommercial-ShareAlike License.
		Feel free to remix this work for non-comercial purposes as long as
		there remains attribution to buzztracker.org. 
		

<!-- Creative Commons License 
	<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">Creative Commons License</a>.
</Creative Commons License -->

*/

// Global variable for "XML" request
//
var req				= null;

var dataLoaded 		= false;
var dateLoaded 		= new Date();

var firstTime 		= true;

var timerInterval 	= null;
var updateInterval 	= 1000*60*60;	// One hour

// Setup the onshow and onhide functions
// setup an interval timer 
// Grab the data via setup() for the first time
function init() {
	
	if (window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
	}

	timerInterval = setInterval("setup()", updateInterval); 
	
	setup();

}

function setup() {

	loadXMLDoc("http://www.buzztracker.org/index.html");

}

// Setup the timer so if you keep the widget on display it will
// update itself every hour
function onShow() {

	if (timerInterval == null) { 
		timerInterval = setInterval("setup()", updateInterval); 
	} 	

	setup();
}

//
// Turn off our timer so the widget
// stops updating when hidden
function onHide() {

	if (timerInterval != null) { 
		clearInterval(timerInterval); 
		timerInterval = null; 
	} 

}

// Force the reload of the buzzImage if it's been running for more than an hour. 
//
function reloadImage() {
    var now = new Date();
	
	var oneHour = 1000*60*60;	// 1000 mili seconds in a sec, 60 seconds in min, 60 mins in hr
	var difference = (now - dateLoaded)/oneHour;	
		
	if ((difference > 1) || firstTime) {	// Has the timer reached 1 hour OR is this the first time running?
		document.getElementById("dailyBuzz").innerHTML = "";
		buzzimg = '<a href="#" onclick="widget.openURL(\'http://www.buzztracker.org/\');"><img src="http://www.buzztracker.org/dailybuzz.png" width="200" height="100" style="border: 4px solid #bbb;" name="dailyBuzzImg"></a>';
		document.getElementById("dailyBuzz").innerHTML = buzzimg;

	    if (document.images) {
    	    document.images.dailyBuzzImg.src = 'http://www.buzztracker.org/dailybuzz.png?' + now.getTime();
	    }
	    dateLoaded = now;
	    firstTime = false;
	}
}

function loadXMLDoc(url) {
   
    if (window.XMLHttpRequest) {
	    
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", url, true);
        req.setRequestHeader("Cache-Control", "no-cache"); 
        req.send(null);  

    } 

}

// handle onreadystatechange event of req object
function processReqChange() {

    // only if req shows "loaded"
    if (req.readyState == 4) {
        // only if "OK"
        if (req.status == 200) {
	        // If the XML was properly loaded then let's update the date
	        // field in the Widget
	        //
            currentDate();
            
            // and parse the top 10 locations from the "xml" data
            //
            topLocations(); 

            // Finally, let's (re)load our dailyBuzz image
            reloadImage();
         } 
         
         else {   
            document.getElementById("topLocationsHead").innerHTML = "Unable to load data";            
           	alert("There was a problem retrieving the XML data:\n" + req.statusText);
        }
    }

}

function currentDate() {

	// Map our numerical instances of months to proper names
	//
	var month = new Array;
	month['01'] = 'January';
	month['02'] = 'February';
	month['03'] = 'March';
	month['04'] = 'April';
	month['05'] = 'May';
	month['06'] = 'June';
	month['07'] = 'July';
	month['08'] = 'August';
	month['09'] = 'September';
	month['10'] = 'October';
	month['11'] = 'November';
	month['12'] = 'December';
	
	// Since we're grabbing an HTML page we can't treat it like XML
	// We can look at the "responseText" and do regExp searches
	// responseXML is unfortunately undefined in this case
	//
	var response = req.responseText;

	// Match for the date ... 
	//
	var regExp = /(\d{4})-(\d{2})-(\d{2})/;
	var result = response.match(regExp);
	
	// Make the date a little more reader friendly ... 
	//
	var newDate = month[result[2]] + " " + result[3] + ", " + result[1];
	
	// Replace the "date" div data with the the current buzztracker date
	//
	document.getElementById("date").innerHTML = newDate;

}

function topLocations() {

	// Pull out our "XML" response text into a variable for RegExp matching
	//
	var response = req.responseText;
	
	// Build our very simple regEx -- we know the page format isn't going to change
	// soon so it's OK if it's this simple.
	//
	var topLoc = /<li>(.+)<\/li>/g;
	var result = response.match(topLoc);
	
	// We need to remix the URL a bit since Widget's don't open browser windows
	// unless you use the widget.openURL javascript command .. So first let's find those
	// urls in the regEx match
	//
	//var urlGrab = /<a (href="(http:\/\/(.+))")>/;
	var urlGrab = /<li>(<a href="(http:\/\/(.+))">)([^<]*?)<\/a><\/li>/;


	var urlSnag = "";
	var newUrl = "";

	// Then go through and re-write the URLs 
	// from <li><a href="URL">location</a></li>
	// to <a href="#" onclick="widget.openURL(URL);"><li>location</li></a>
	// Sort of a pain in the ass but necessary.
	// This increases the "hit-zone" for the locations so you don't have to
	// click precisely on the word -- you can click within the <li> element 
	//
	for (i = 0; i < 10; i++) {
		urlSnag = result[i].match(urlGrab);
		
		// Hack to get around widget.openURL whitespace issue 
		//   -- we check for whitespace in the URL. If found, we open the URL via: 
		//		widget.system('/usr/bin/open URL', null);
		// 	This unfortunately opens the window behind the widget, but it's still better than nothing.
		//
		var whiteSpace = /(\S+\s\S+) \(\d{2}%\)/;
		var isSpace = urlSnag[4].match(whiteSpace);
		//alert(isSpace + ' -> ' + urlSnag[4]);			// DEBUG
		
		if (isSpace == null) {
			newUrl = "<a href=\"#\" onclick=\"widget.openURL('" + urlSnag[2] + "');\"><li>" + urlSnag[4] + "</li></a>";
		}
		else {
			urlSnag[2] = urlSnag[2].replace(/\s/gi, "%20");
			newUrl = "<a href=\"#\" onclick=\"widget.system('/usr/bin/open " + urlSnag[2] + "', null);\"><li>" + urlSnag[4] + "</li></a>";
		}
		result[i] = result[i].replace(urlSnag[0], newUrl);

	}

	// Build the list of locations - 1 to 10 locations based on user prefs (?)
	//
	var locationListLeft = "<ul>";
	var locationListRight = "<ul>";

	for (i = 0; i < 5; i++) {
		locationListLeft = locationListLeft + result[i];
	}

	for (i = 5; i < 10; i++) {
		locationListRight = locationListRight + result[i];
	}

	locationListLeft = locationListLeft + "</ul>";
	locationListRight = locationListRight + "</ul>";
	
	// Replace the text of the Location list witht he appropriate number
	// of locations + links. 
	document.getElementById("locationListLeft").innerHTML 	= locationListLeft;
	document.getElementById("locationListRight").innerHTML 	= locationListRight;
	document.getElementById("topLocationsHead").innerHTML 	= "Top 10 Locations";
	
}

function turnOn(divId) {
	document.getElementById(divId).style.display = 'block';
}

function turnOff(divId) {
	document.getElementById(divId).style.display = 'none';
}

//******************************//
// Everything below this --
// functions Apple provided 
// in their example widgets.
// Modified in some cases.
//******************************//

// Apple functions to flip the widget
//
function showBack() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);  
} 

function hideBack() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    back.style.display="none"; 
    front.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0); 

	// If we don't turn this off then the 'fliprollie' id is still showing when the 
	// widget flips back to the front. 
	//
	turnOff("fliprollie"); // Man, who came up with that name? 
	
    setup();
} 


// ------------------- //
// Animate Buzz Button //
// -- A modified preferences animation to fade in the overlay atop the buzztracker mini-map. 
//

var buzzShown = false;
var buzzAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function buzzmove (event)
{
	if (!buzzShown)
	{
		if (buzzAnimation.timer != null)			// reset the buzzAnimation timer value, in case a value was left behind
		{
			clearInterval (buzzAnimation.timer);
			buzzAnimation.timer  = null;
		}
		
		var buzzstarttime = (new Date).getTime() - 13; 		// set it back one frame
		
		buzzAnimation.duration = 300;												// buzzAnimation time, in ms
		buzzAnimation.starttime = buzzstarttime;										// specify the start time
		buzzAnimation.firstElement = document.getElementById ('mapButtonOver');		// specify the element to fade
		buzzAnimation.timer = setInterval ("buzzAnimate();", 13);						// set the buzzAnimation function
		buzzAnimation.from = buzzAnimation.now;											// beginning opacity (not ness. 0)
		buzzAnimation.to = 1.0;														// final opacity
		buzzAnimate();																// begin buzzAnimation
		buzzShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the buzzAnimation data structure and sets the buzzAnimation in motion.

function buzzexit (event)
{
	if (buzzShown)
	{
		// fade in the flip widget
		if (buzzAnimation.timer != null)
		{
			clearInterval (buzzAnimation.timer);
			buzzAnimation.timer  = null;
		}
		
		var buzzstarttime = (new Date).getTime() - 13;
		
		buzzAnimation.duration = 300;
		buzzAnimation.starttime = buzzstarttime;
		buzzAnimation.firstElement = document.getElementById ('mapButtonOver');
		buzzAnimation.timer = setInterval ("buzzAnimate();", 13);
		buzzAnimation.from = buzzAnimation.now;
		buzzAnimation.to = 0.0;
		buzzAnimate();
		buzzShown = false;
	}
}

function buzzAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	T = limit_3(time-buzzAnimation.starttime, 0, buzzAnimation.duration);
	
	if (T >= buzzAnimation.duration)
	{
		clearInterval (buzzAnimation.timer);
		buzzAnimation.timer = null;
		buzzAnimation.now = buzzAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / buzzAnimation.duration));
		buzzAnimation.now = computeNextFloat (buzzAnimation.from, buzzAnimation.to, ease);
	}
	
	buzzAnimation.firstElement.style.opacity = buzzAnimation.now;
}


//-------------//


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)
var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.

// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}